import es, gamethread, random, popuplib, playerlib, cfglib, services, usermsg, langlib

info = es.AddonInfo()
info.name     = "SIC-Deathmatch"
info.version  = "3.9"
info.url      = "None"
info.basename = "sic_dm"
info.author   = "sicman_adrian"
es.ServerVar('sic_dm', info.version, info.name).makepublic()

method = "spe"

try:
   import spe
   from spe.games import cstrike 
except ImportError:
    if es.exists("variable", "est_version"):
        method = "est"
    else:
        es.dbgmsg(0, "**************SIC-Deathmatch**************")
        es.dbgmsg(0, "Your server does not meet the requirements, This script be unloaded.")
        es.dbgmsg(0, "To meet the requirements you will need to Download")
        es.dbgmsg(0, "Es_Tools or SPE from following links")
        es.dbgmsg(0, "SPE - http://forums.eventscripts.com/viewtopic.php?t=29657#269624")
        es.dbgmsg(0, "EST - http://forums.eventscripts.com/viewtopic.php?t=3413#26833")
        es.dbgmsg(0, "*******************************************")
        es.server.queuecmd("es_unload deathmatch")

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/deathmatch.cfg')
config.text("********************")
config.text(" Guns Menu Settings And Respawn")
config.text("********************")
deathmatch_menu_enable   = config.cvar("deathmatch_menu_enable",   1, "This enables and Disables weapon menu")
deathmatch_random_weapons   = config.cvar("deathmatch_random_weapons",   0, "Disables Gun menu and Gives random weapons")
deathmatch_primaryweapons = config.cvar("deathmatch_primary_names",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry menu list")
deathmatch_secondary = config.cvar("deathmatch_pistol_names",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol menu list")
deathmatch_bot_primaryweapons = config.cvar("deathmatch_bot_primaryweapons",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry bot weapons")
deathmatch_bot_secondary = config.cvar("deathmatch_bot_secondary",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol bot weapons")
deathmatch_respawn_enabled   = config.cvar("deathmatch_respawn_enabled",   1, "Respawns a player")
deathmatch_deadtime   = config.cvar("deathmatch_deadtime",   0.1, "How long till they respawn")
config.text("********************")
config.text("     Disssolver     ")
config.text("********************")
deathmatch_deathtype = config.cvar("deathmatch_deathtype",      6, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
deathmatch_deathtime   = config.cvar("deathmatch_deathtime",   3, "How long bodie Stays")
config.text("\n")
config.text("*************************")
config.text("        Round End        ")
config.text("*************************")
deathmatch_roundend_enable   = config.cvar("deathmatch_roundend_enable",   1, "Enable Round end")
config.text("\n")
config.text("*************************")
config.text("Spawn Protection Settings")
config.text("*************************")
deathmatch_spawn_protection   = config.cvar("deathmatch_spawn_protection",   1, "Enable or Disable Spawn Protection")
deathmatch_protection_time   = config.cvar("deathmatch_protection_time",   2.5, "Time Protected")
deathmatch_protection_type   = config.cvar("deathmatch_protection_type",   'god', "Spawn Protection Types are god or Health")
deathmatch_protection_alpha   = config.cvar("deathmatch_protection_alpha",   100, " Alpha When spawned ,100 half invisible, Default 255")
config.text("*****Health Settings*****")
deathmatch_protection_health   = config.cvar("deathmatch_protection_health",   1124, " Protection Health ,Recommend 1124")
config.text("\n")
config.text("*************************")
config.text("       GamesModes        ")
config.text("*************************")
deathmatch_gamemodes_enable = config.cvar("deathmatch_gamemodes_enable",   1, "Enable/Disable gamemodes")
deathmatch_gamemodes_ffa = config.cvar("deathmatch_gamemodes_ffa",   0, "Enable/Disable Free For All")
deathmatch_gamemodes_redvsblue = config.cvar("deathmatch_gamemodes_redvsblue",   0, "Red Vs Blue Gamemode,So far Red vs blue Is just Blue and Red Master Chief skins for both teams")
deathmatch_gamemodes_headshotonly = config.cvar("deathmatch_gamemodes_headshotonly",   0, "Head Shot Only Gamemode")
config.text("\n")
config.text("**************************")
config.text("       Red Vs Blue        ")
config.text("**************************")
deathmatch_redvsblue_disable_downloads = config.cvar("deathmatch_redvsblue_disable_downloads",   0, "Change to 1 if you are using fast downloads or mani")
deathmatch_redvsblue_redmodel_folder   = config.cvar("deathmatch_redvsblue_redmodel_folder",   'models/player/bic/', "Ct model path used for downloads")
deathmatch_redvsblue_bluemodel_folder   = config.cvar("deathmatch_redvsblue_bluemodel_folder",   'models/player/bic/', "T's Model path used for downloads")
deathmatch_redvsblue_red_model   = config.cvar("deathmatch_redvsblue_red_model",   'models/player/bic/t_arctic.mdl', "Terriost Model")
deathmatch_redvsblue_blue_model   = config.cvar("deathmatch_redvsblue_blue_model",   'models/player/bic/ct_sas.mdl', "Ct Model")
deathmatch_redvsblue_pushscale = config.cvar("deathmatch_redvsblue_pushscale",   400, "Makes Ragdolls fly")
deathmatch_redvsblue_energyhe = config.cvar("deathmatch_redvsblue_energyhe",   1, "Hegrenades will be like the energy grenades in halo")
config.text("\n")
config.text("*************************")
config.text("         Extras          ")
config.text("*************************")
deathmatch_noblock   = config.cvar("deathmatch_noblock",   1, "Enable and Disables noblock Allowing people to walk throught other players")
deathmatch_spec   = config.cvar("deathmatch_spec",   1, "Allows players to go spec using !spec in chat")
deathmatch_givekevlar   = config.cvar("deathmatch_givekevlar",   1, "Option to give players Kevlars")
deathmatch_grenades = config.cvar("deathmatch_grenades",   'hegrenade flashbang smokegrenade', "Nades given when player spawns")
deathmatch_unlimitednade   = config.cvar("deathmatch_unlimitednade",   1, "Gives Players Unlimited Nades")
config.text("\n")
config.text("*************************")
config.text("      SpawnPoints        ")
config.text("*************************")
deathmatch_spawnpoints   = config.cvar("deathmatch_spawnpoints",   0, "Loads Spawnpoints")

config.write()

player_dict = {}
weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}
text = None
weapon_list = ['M4A1','AK47','AWP','Scout','SG552', 'Galil','Famas','SG550','AUG','m249','G3SG1','UMP45','MP5NAVY','M3','xm1014','TMP','Mac10', 'P90','Usp','Glock','Deagle','P228','Elite','FiveSeven']


# ======================#
#     MODELS&MATERIALS
# ======================#
# Thanks to bonbon for all the downloads ables help
model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(deathmatch_redvsblue_redmodel_folder)
model_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + str(deathmatch_redvsblue_bluemodel_folder)
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/redmc/'
material_folder2 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/player/bic/bluemc/'



class player:
    def __init__(self, userid):
        self.userid = userid
        self.primary = 0
        self.secondary = 0
        self.gunmenu = 1
        self.protected = 0
        self.prevteam = 0
    def Giveweapons(self):
        self.strip()
        self.Givegrenades()
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, self.primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, self.secondary))
    def Giverandom(self):
        self.strip()
        self.Givegrenades()
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_primaryweapons).split())))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_secondary).split())))
    def strip(self):
        es.server.queuecmd('es_xfire %s player_weaponstrip kill' % self.userid)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % self.userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % self.userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % self.userid)
    def Givegrenades(self):
        for c in str(deathmatch_grenades).split():
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' %(self.userid, c))
    def spawn(self):
        es.server.queuecmd('es_xfire %s game_weapon_manager AddOutput "maxpieces 0"' % self.userid)
        if es.isbot(self.userid):
            if int(deathmatch_menu_enable) == 1:
                self.strip()
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_primaryweapons).split())))
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (self.userid, random.choice(str(deathmatch_secondary).split())))
        else:
            if int(deathmatch_menu_enable) == 1:
                if self.gunmenu == 1:
                    sicdm_gunsmenu.unsend(self.userid)
                    sicdm_gunsmenu.send(self.userid)
                elif self.gunmenu == 2:
                      self.Giveweapons()
                elif self.gunmenu == 3:
                      self.Giverandom()
        if int(deathmatch_givekevlar) == 1:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s item_assaultsuit' % self.userid)
        if int(deathmatch_noblock) == 1:
            es.setplayerprop(self.userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
        self.protection()
    def protection(self):
        myPlayer = playerlib.getPlayer(self.userid)
        if str(deathmatch_protection_type) == 'health':
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', deathmatch_protection_health)
        else:
            es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_lifeState', 0)
        myPlayer.set("color", (255, 255, 255, deathmatch_protection_alpha))
        self.protected = 1
        gamethread.delayedname(deathmatch_protection_time, 'removeprotection%s'% self, self.removeprotection)
    def removeprotection(self):
        myPlayer = playerlib.getPlayer(self.userid)
        if str(deathmatch_protection_type) == 'health':
            myPlayer.set("color", (255, 255, 255, 255))
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', 100) 
            self.protected = 0
        else:
            myPlayer.set("color", (255, 255, 255, 255))
            es.setplayerprop(self.userid, 'CCSPlayer.baseclass.m_lifeState', 512)
            self.protected = 0
    def dissolve(self):
        global mode
        if int(deathmatch_deathtype) == 6:
            mode = random.randint(1,5)
        else:
            mode = deathmatch_deathtype
        if mode == 1:
            es.delayed(deathmatch_deathtime, 'es_xfire %s cs_ragdoll kill' % self.userid)
            es.delayed(deathmatch_deadtime, 'est_spawn %s 0'% self.userid)
        else:
            es.delayed(deathmatch_deathtime, 'es_xgive %s env_entity_dissolver' % self.userid)
            es.delayed(deathmatch_deathtime, 'es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll"' % self.userid)
            es.delayed(deathmatch_deathtime, 'es_xfire %s env_entity_dissolver AddOutput "magnitude 1"' % self.userid)
            es.delayed(deathmatch_deathtime, 'es_xfire %s env_entity_dissolver AddOutput "dissolvetype %s"' % ( self.userid,mode))
            es.delayed(deathmatch_deathtime, 'es_xfire %s env_entity_dissolver Dissolve' % self.userid)

def load():
    global sicdm_gunsmenu, primarymenu, pistolmenu, text
    config.execute()
    text = langlib.Strings(es.getAddonPath("deathmatch") + "/strings.ini")
    es.msg('#multi', text("load"))
    setup_auth()
    if not es.exists('command', 'guns'):
        es.regsaycmd('guns', 'deathmatch/main')
    if not es.exists('command', '!sicadmin'):
        es.regsaycmd('!sicadmin', 'deathmatch/admin')
    if not es.exists('command', '!spec'):
        es.regsaycmd('!spec', 'deathmatch/spec')
    es.doblock('corelib/noisy_on')
    es.flags('remove', 'cheat', 'endround')
    sicdm_gunsmenu = popuplib.create('sicdm_gunsmenu')
    sicdm_gunsmenu.addline('Deathmatch')
    sicdm_gunsmenu.addline('----------------------')
    sicdm_gunsmenu.addline('->1. New weapons')
    sicdm_gunsmenu.addline('->2. Same weapons')
    sicdm_gunsmenu.addline('->3. Same weapons every time')
    sicdm_gunsmenu.addline('->4. Random weapons')
    sicdm_gunsmenu.addline('->5. Random weapons every time')
    sicdm_gunsmenu.addline('----------------------')
    sicdm_gunsmenu.menuselect = sicdm_gunsmenu_menuselect
    sicdm_primarymenu = popuplib.easymenu('sicdm_primarymenu', '_popup_choice', primarymenu_menuselect)
    sicdm_primarymenu.settitle('Primary weapons')
    for c in str(deathmatch_primaryweapons).split(): sicdm_primarymenu.addoption(c, c)
    sicdm_pistolmenu = popuplib.easymenu('sicdm_pistolmenu', '_popup_choice', pistolmenu_menuselect)
    sicdm_pistolmenu.settitle('Pistols')
    for c in str(deathmatch_secondary).split(): sicdm_pistolmenu.addoption(c, c)
    if int(deathmatch_gamemodes_enable) == 1:
        if int(deathmatch_gamemodes_headshotonly) == 1 or deathmatch_gamemodes_ffa == 1:
            if method == "spe":
                spe.registerPreHook('player_hurt', pre_hurt)
            else:
                es.server.queuecmd('est_RegEventBlock player_hurt "es_xdoblock deathmatch/pre_hurt"')
        if deathmatch_gamemodes_ffa == 1:
            es.ServerVar('mp_friendlyfire').set(1)
        if int(deathmatch_gamemodes_redvsblue) == 1:
            es.server.queuecmd('phys_pushscale %s' % deathmatch_redvsblue_pushscale)
            if int(deathmatch_redvsblue_energyhe):
                es.addons.registerTickListener(TickListener)
            if not int(deathmatch_redvsblue_disable_downloads):
                downloadskins()
    if int(deathmatch_spawn_protection) == 1:
        es.msg('#multi', text("spawn load"))
    if int(deathmatch_random_weapons) == 1:
        deathmatch_menu_enable = 0
    sicdm_adminmenu = popuplib.create('sicdm_adminmenu')
    sicdm_adminmenu.addline('Deathmatch Admin')
    sicdm_adminmenu.addline('--------------------')
    sicdm_adminmenu.addline('->1. Spawn Protection')
    sicdm_adminmenu.addline('->2. Guns menu')
    sicdm_adminmenu.addline('->3. Gamemodes')
    sicdm_adminmenu.addline('->4. Dissolver')
    sicdm_adminmenu.addline('->5. Extras')
    sicdm_adminmenu.addline('->0. Exit')
    sicdm_adminmenu.addline('--------------------')
    sicdm_adminmenu.menuselect = adminmenu_menuselect

    sicdm_protection = popuplib.create('sicdm_protection')
    sicdm_protection.addline('Deathmatch Spawn Protection')
    sicdm_protection.addline('--------------------')
    sicdm_protection.addline('->1. Enable Protection')
    sicdm_protection.addline('->2. Disable Protection')
    sicdm_protection.addline('->3. God Protection Mode')
    sicdm_protection.addline('->4. Health Protection Mode')
    sicdm_protection.addline('->8. Back')
    sicdm_protection.submenu(8,'adminmenu')
    sicdm_protection.addline('->0. Exit')
    sicdm_protection.addline('--------------------')
    sicdm_protection.menuselect = protection_menuselect

    sicdm_gunmenu = popuplib.create('sicdm_gunmenu')
    sicdm_gunmenu.addline('Deathmatch Gun Menu')
    sicdm_gunmenu.addline('--------------------')
    sicdm_gunmenu.addline('->1. Enable Gun Menu')
    sicdm_gunmenu.addline('->2. Disable Gun Menu')
    sicdm_gunmenu.addline('->8. Back')
    sicdm_gunmenu.submenu(8,'adminmenu')
    sicdm_gunmenu.addline('->0. Exit')
    sicdm_gunmenu.addline('--------------------')
    sicdm_gunmenu.menuselect = gunmenu_menuselect

    sicdm_extra = popuplib.create('sicdm_extra')
    sicdm_extra.addline('Deathmatch Extra Menu')
    sicdm_extra.addline('--------------------')
    sicdm_extra.addline('->1. Enable Noblock')
    sicdm_extra.addline('->2. Disable Noblock')
    sicdm_extra.addline('->8. Back')
    sicdm_extra.submenu(8,'adminmenu')
    sicdm_extra.addline('->0. Exit')
    sicdm_extra.addline('--------------------')
    sicdm_extra.menuselect = extra_menuselect

    sicdm_gamemodesmenu = popuplib.create('sicdm_gamemodesmenu')
    sicdm_gamemodesmenu.addline('Deathmatch Gamemodes')
    sicdm_gamemodesmenu.addline('-----------------------')
    sicdm_gamemodesmenu.addline('->1. Load Red vs Blue')
    sicdm_gamemodesmenu.addline('->2. Unload Red vs Blue')
    sicdm_gamemodesmenu.addline('->3. Load Head Shot Only')
    sicdm_gamemodesmenu.addline('->4. Unload Head Shot Only')
    sicdm_gamemodesmenu.addline('->8. Back')
    sicdm_gamemodesmenu.submenu(8,'adminmenu')
    sicdm_gamemodesmenu.addline('->0. Exit')
    sicdm_gamemodesmenu.addline('------------------------')
    sicdm_gamemodesmenu.menuselect = gamemodesmenu_menuselect
    
    sicdm_deathtypemenu = popuplib.create('sicdm_deathtypemenu')
    sicdm_deathtypemenu.addline('Deathmatch Dissolver')
    sicdm_deathtypemenu.addline('-----------------------')
    sicdm_deathtypemenu.addline('->1. No Dissovle')
    sicdm_deathtypemenu.addline('->2. Energy Effect')
    sicdm_deathtypemenu.addline('->3. Heavy Electrical Effect')
    sicdm_deathtypemenu.addline('->4. Light Electrical')
    sicdm_deathtypemenu.addline('->5. Core Effect')
    sicdm_deathtypemenu.addline('->6. Random')
    sicdm_deathtypemenu.addline('->8. Back')
    sicdm_deathtypemenu.submenu(8,'adminmenu')
    sicdm_deathtypemenu.addline('->0. Exit')
    sicdm_deathtypemenu.addline('------------------------')
    sicdm_deathtypemenu.menuselect = deathtypemenu_menuselect

# Sending the submenu's
def adminmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        popuplib.send('sicdm_protection', userid)
        es.cexec(userid, 'play buttons/button24')
    elif choice == 2:
          popuplib.send('sicdm_gunmenu', userid)
          es.cexec(userid, 'play buttons/button24')
    elif choice == 3:
          popuplib.send('sicdm_gamemodesmenu', userid)
          es.cexec(userid, 'play buttons/button24')
    elif choice == 4:
          popuplib.send('sicdm_deathtypemenu', userid)
          es.cexec(userid, 'play buttons/button24')
    elif choice == 5:
          popuplib.send('sicdm_extra', userid)
          es.cexec(userid, 'play buttons/button24')

# Now changing and unloading 
def protection_menuselect (userid, choice, popupid):
    global spawn_protection
    global protection_god
    if choice == 1:
        deathmatch_spawn_protection = 1
        es.msg('#multi', text("spawn load"))
        es.cexec(userid, 'play buttons/button24')
        popuplib.send('sicdm_protection', userid)
    elif choice == 2:
          deathmatch_spawn_protection = 0
          es.msg('#multi', text("spawn unload"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_protection', userid)
    elif choice == 3:
          deathmatch_protection_god = 1
          es.msg('#multi', text("spawn god"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_protection', userid)
    elif choice == 4:
          deathmatch_protection_god = 0
          es.msg('#multi', text("spawn health"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_protection', userid)

def gunmenu_menuselect (userid, choice, popupid):
    global deathmatch_menu_enable
    if choice == 1:
        deathmatch_menu_enable = 1
        es.msg('#multi', text("gun menu enabled"))
        es.cexec(userid, 'play buttons/button24.wav')
        popuplib.send('sicdm_gunmenu', userid)
    elif choice == 2:
          deathmatch_menu_enable = 0
          es.msg('#multi', text("gun menu disable"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_gunmenu', userid)

def gamemodesmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        deathmatch_gamemodes_redvsblue == 1
        es.msg('#multi', text("rvb enabled"))
        es.cexec(userid, 'play buttons/button24')
        popuplib.send('sicdm_gamemodesmenu', userid)
    elif choice == 2:
          deathmatch_gamemodes_redvsblue == 0
          es.msg('#multi', text("rvb disabled"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_gamemodesmenu', userid)
    elif choice == 3:
          es.server.queuecmd('est_RegEventBlock player_hurt "es_xdoblock deathmatch/pre_hurt"' )
          es.msg('#multi', text("headshot enabled"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_gamemodesmenu', userid)
    elif choice == 4:
          es.server.queuecmd('est_UnRegEventBlock player_hurt "es_xdoblock deathmatch/pre_hurt"' )
          es.msg('#multi', text("headshot disable"))
          popuplib.send('gamemodesmenu', userid)
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_gamemodesmenu', userid)

def extra_menuselect (userid, choice, popupid):
    global noblock
    if choice == 1:
        deathmatch_noblock = 1
        es.msg('#multi', text("noblock enable"))
        es.cexec(userid, 'play buttons/button24')
        popuplib.send('sicdm_extra', userid)
    elif choice == 2:
          deathmatch_noblock = 0
          es.msg('#multi', text("noblock disable"))
          es.cexec(userid, 'play buttons/button24')
          popuplib.send('sicdm_extra', userid)

def deathtypemenu_menuselect (userid, choice, popupid):
    global deathmatch_deathtype
    if choice >= 6:
        deathmatch_deathtype = choice
        es.cexec(userid, 'play buttons/button24')
        popuplib.send('sicdm_deathtypemenu', userid)

def unload():
    for popup in ['sicdm_gunsmenu','sicdm_gamemodesmenu','sicdm_pistolmenu','sicdm_primarymenu','sicdm_adminmenu','sicdm_protection','sicdm_gunmenu','sicdm_extra','sicdm_deathtypemenu']:
        popuplib.delete(popup)
    es.server.queuecmd('es_unload deathmatch/spawnpoints')
    es.doblock('corelib/noisy_off')
    if int(deathmatch_gamemodes_headshotonly ) == 1:
        es.server.queuecmd('est_UnRegEventBlock player_hurt "es_xdoblock deathmatch/pre_hurt"')
    if es.exists('command', 'guns'):
        es.unregsaycmd('guns')
    if es.exists('command', '!sicadmin'):
        es.unregsaycmd('!sicadmin')
    if es.exists('command', '!spec'):
        es.unregsaycmd('!spec')
    spe.unregisterPreHook('player_hurt', pre_hurt)

def downloadskins():
    for dlfile in os.listdir(model_folder1):
        es.stringtable('downloadables', model_folder1 + dlfile)
    for dlfile in os.listdir(model_folder2):
        es.stringtable('downloadables', model_folder2 + dlfile)
    for dlfile in os.listdir(material_folder1):
        es.stringtable('downloadables', material_folder1 + dlfile)
    for dlfile in os.listdir(material_folder2):
        es.stringtable('downloadables', material_folder2 + dlfile)

def es_map_start(ev):
    if int(deathmatch_gamemodes_redvsblue) == 1:
        if not deathmatch_redvsblue_disable_downloads:
            downloadskins()

def player_activate(ev):
    player_dict[ev['userid']] = player(ev['userid'])

def sicdm_gunsmenu_menuselect (userid, choice, popupid):
    userid = str(userid)
    if choice == 1:
        popuplib.send('sicdm_pistolmenu', userid)
        es.cexec(userid, 'play buttons/button24')
    elif choice == 2:
          if player_dict[userid].primary in weapon_list and player_dict[userid].secondary in weapon_list:
                player_dict[userid].Giveweapons()
                es.cexec(userid, 'play buttons/button24')
          else:
              sicdm_gunsmenu.unsend(userid)
              sicdm_gunsmenu.send(userid)
    elif choice == 3:
          if player_dict[userid].primary in weapon_list and player_dict[userid].secondary in weapon_list:
                  player_dict[userid].Giveweapons()
                  player_dict[userid].gunmenu = 2
                  es.cexec(userid, 'play buttons/button24')
          else:
              sicdm_gunsmenu.unsend(userid)
              sicdm_gunsmenu.send(userid)
    elif choice == 4:
          player_dict[userid].Giverandom()
          es.cexec(userid, 'play buttons/button24')
    elif choice == 5:
          player_dict[userid].Giverandom()
          es.cexec(userid, 'play buttons/button24')
          player_dict[userid].gunmenu = 3
 
def primarymenu_menuselect (userid, choice, popupid):
    player_dict[str(userid)].primary = choice
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))
    es.cexec(userid, 'play buttons/button24')

def pistolmenu_menuselect (userid, choice, popupid):
    userid = str(userid)
    player_dict[str(userid)].secondary = choice
    player_dict[userid].strip()
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))
    popuplib.send('sicdm_primarymenu', userid)
    es.cexec(userid, 'play buttons/button24')

def player_spawn(ev):
    userid = ev['userid']
    if ev['es_userteam'] >= '2':
        player_dict[userid].spawn()
    if int(deathmatch_gamemodes_enable) == 1:
        if int(deathmatch_gamemodes_redvsblue) == 1:
            if ev['es_userteam'] == '2':
                myPlayer.set('model', str(redvsblue_red_model))
            elif ev['es_userteam'] == '3':
                  myPlayer.set('model', str(redvsblue_blue_model))

def flashbang_detonate(ev):
    userid = ev['userid']
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade) == 1:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)

def smokegrenade_detonate(ev):
    userid = ev['userid']
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade) == 1:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_smokegrenade' % userid)

def hegrenade_detonate(ev):
    userid = ev['userid']
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        if int(deathmatch_unlimitednade) == 1:
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_hegrenade' % userid)

def player_hurt(ev):
    userid = ev['userid']
    if player_dict[userid].protected == 1:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', deathmatch_protection_health)
    if int(deathmatch_gamemodes_ffa) == 1:
        cstrike.switchTeam(int(userid), player_dict[userid].prevteam) 

def weapon_reload(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if weapon in weapon_ammo_dict:
        myPlayer.set('ammo',(weapon,weapon_ammo_dict[weapon]))

def player_death(ev):
    userid = ev['userid']
    if int(deathmatch_respawn_enabled) == 1:
        gamethread.cancelDelayed('respawn'+ ev['userid'])
        gamethread.delayedname(deathmatch_deadtime, 'respawn%s'% userid, respawn, userid)
    player_dict[userid].dissolve()

def respawn(userid):
    if method == "spe":
        cstrike.respawn(int(userid))
    else:
        est('spawn %s 0' % userid)

def player_team(ev):
    userid = ev['userid']
    if int(ev['team']) > 1:
        gamethread.cancelDelayed('respawn'+ ev['userid'])
        gamethread.delayedname(3, 'respawn%s'% userid, respawn, userid)

def round_start(ev):
    userid = es.getuserid()
    roundtime = es.ServerVar("mp_roundtime") * 60 + es.ServerVar("mp_freezetime")
    if int(deathmatch_roundend_enable) == 1:
        gamethread.cancelDelayed('round_end')
        gamethread.delayedname(roundtime, 'round_end', es.server.queuecmd, 'endround')
    if userid:
        gamethread.delayed(10, usermsg.hudhint, ('#all', text('hudhint')))
        es.server.queuecmd('es_xfire %s func_hostage_rescue kill'% userid)
        es.server.queuecmd('es_xfire %s hostage_entity kill'% userid)
        es.server.queuecmd('es_xfire %s func_bomb_target kill'% userid)
        es.server.queuecmd('es_xfire %s func_buyzone kill'% userid)


# COMMANDS SECTION #
def spec():
    if int(deathmatch_spec) == 1:
        es.server.queuecmd('es_changeteam %s 1'% es.getcmduserid())

def main():
    if int(deathmatch_menu_enable) == 1:
        sicdm_gunsmenu.unsend(str(es.getcmduserid()))
        sicdm_gunsmenu.send(str(es.getcmduserid()))
    else:
        es.tell(str(es.getcmduserid()), '#multi','Guns Menu is disabled')

def admin():
    userid = str(es.getcmduserid())
    if isAuthed(userid):
        popuplib.unsend('sicdm_adminmenu', userid)
        popuplib.send('sicdm_adminmenu', userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorized to run this command')


def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('deathmatch_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'deathmatch_admin')
    else:
        isAuthed = lambda x: False

def est(args):
    es.server.cmd('est_' + args)

def pre_hurt(ev=None):
    if ev is None: 
        est('GetEventInfo hs_userid userid')
        est('GetEventInfo hs_hitgroup hitgroup')
    else:
        userid = ev['userid']
        hitgroup = ev['hitgroup']
    if int(deathmatch_gamemodes_headshotonly) == 1:
        if hitgroup > 1:
            es.setplayerprop(userid, "CBasePlayer.m_iHealth", 100)
    if int(deathmatch_gamemodes_ffa) == 1:
        if method == "spe":
            attacker = ev['attacker']
            if es.getplayerteam(userid) == es.getplayerteam(attacker):
                if es.getplayerteam(userid) == 2:
                    cstrike.switchTeam(int(userid), 3) 
                    player_dict[userid].prevteam = 3
                else:
                    cstrike.switchTeam(int(userid), 2) 
                    player_dict[userid].prevteam = 2
        else:
            es.dbgmsg(0, "SIC-Deathmatch: FFA Requires SPE to work")

def player_disconnect(ev):
    userid = ev['userid']
    if es.exists('userid', userid):
        del player_dict[userid]
        gamethread.cancelDelayed('removeprotection'+ ev['userid'])
        gamethread.cancelDelayed('respawn'+ ev['userid'])